<?php
	session_start();
	$username = $_SESSION['Username'];
	$settings = json_decode(file_get_contents("../source/cfg/preferences.config"), true);
	$valid_username = $settings["username"];
	$valid_password = $settings["password"];
	if(strtolower($username) == strtolower($valid_username)) {
		$logged_in = true;
	}
	
	$action = $_POST['action'];
	
	if($action == "login") {
		if(!empty($_POST['username']) && !empty($_POST['password'])) {			
			$username = strtolower($_POST['username']);
			$password = hash("sha512", $_POST['password']);
			
			$settings = json_decode(file_get_contents("../source/cfg/preferences.config"), true);
			$valid_username = $settings["username"];
			$valid_password = $settings["password"];
			
			if(strtolower($username) == strtolower($valid_username) && $password == strtolower($valid_password)) {
				$_SESSION['Username'] = $valid_username;
				echo "Loading...";
			}
			else {
				echo "This area is restricted to admins only.";
			}
		}
		else {
			echo "Please fill out both input fields.";
		}
	}
	if($action == "logout") {
		session_start();
		session_destroy();
		$_SESSION = array();
	}
	
	if($logged_in) {
		if($action == "upload-file") {
			@set_time_limit(5 * 60);
			
			$location = str_replace("../", "", $_POST['location']);
			$file_size = $_FILES['file']['size'];
			$file_name = $_REQUEST["name"];
			$file_size_max = 6000000000;
			
			$file_extension = strtolower(array_pop(explode(".", $file_name)));
			if(empty($file_extension)) {
				$file_extension_corrected = $file_extension;
			}
			else {
				$file_extension_corrected = "." . $file_extension;
			}
			$file_name_no_extension = str_replace("." . $file_extension, "", $file_name);
			
			$whitelist = ["jpg","jpeg","png","icns","ico","bmp","gif","psd","mkv","mov","mp4","m4v","avi","ts","flv","wmv","m4p","3gp","webm","mp3","wav","ogg","aac","aiff","m4a","wma","pdf","exe","pkg","msi","py","sh","command","php","html","htm","css","js","config","ini","xml","ipa","apk","rar","zip","dmg","iso","7z","txt","rtf","doc","docx", ""];
			
			if(in_array($file_extension, $whitelist) && $file_size < $file_size_max) {
				$upload_location = "../files/" . $location;
				$file_tmp = $_FILES['file']['tmp_name'];
				$file_path = $upload_location . $file_name;
				if(file_exists($file_path)) {
					$i = 1;
					while(file_exists($file_path)) {
						$file_path = $upload_location . $file_name_no_extension . " (" . $i . ")" . $file_extension_corrected;
						$i++;
					}
				}
				$chunk = isset($_REQUEST["chunk"]) ? intval($_REQUEST["chunk"]) : 0;
				$chunks = isset($_REQUEST["chunks"]) ? intval($_REQUEST["chunks"]) : 0;
				if(!$out = @fopen("{$file_path}.part", $chunks ? "ab" : "wb")) {
					die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
				}
				if(!empty($_FILES)) {
					if($_FILES["file"]["error"] || !is_uploaded_file($_FILES["file"]["tmp_name"])) {
						die('{"jsonrpc" : "2.0", "error" : {"code": 103, "message": "Failed to move uploaded file."}, "id" : "id"}');
					}
					if(!$in = @fopen($_FILES["file"]["tmp_name"], "rb")) {
						die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
					}
				} 
				else {	
					if(!$in = @fopen("php://input", "rb")) {
						die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
					}
				}
				while($buff = fread($in, 4096)) {
					fwrite($out, $buff);
				}
				@fclose($out);
				@fclose($in);
				if(!$chunks || $chunk == $chunks - 1) {
					rename("{$file_path}.part", $file_path);
				}
				die('{"jsonrpc" : "2.0", "result" : null, "id" : "id"}');
			}
		}
		
		if($action == "create-folder") {
			$location = str_replace("../", "", $_POST['location']);
			$file_path = "../files/" . $location . "/" . "New Folder";
			if(file_exists($file_path)) {
				$i = 1;
				while(file_exists($file_path)) {
					$file_path = "../files/" . $location . "/" . "New Folder (" . $i . ")";
					$i++;
				}
			}
			mkdir($file_path);
		}
		if($action == "create-file") {
			$location = str_replace("../", "", $_POST['location']);
			$file_path = "../files/" . $location . "/" . "New File";
			if(file_exists($file_path)) {
				$i = 1;
				while(file_exists($file_path)) {
					$file_path = "../files/" . $location . "/" . "New File (" . $i . ")";
					$i++;
				}
			}
			$file = fopen($file_path, "w");
			fwrite($file, "");
			fclose($file);
		}
		if($action == "delete-file") {
			$location = str_replace("../", "", $_POST['location']);
			$file = "../files/" . $location;
			
			if(realpath($file) != realpath("../files/")) {
				function rrmdir($dir) {
					$structure = glob(rtrim($dir, "/") . '/*');
					if(is_array($structure)) {
						foreach($structure as $file) {
							if(is_dir($file)) rrmdir($file);
							elseif(is_file($file)) unlink($file);
						}
					}
					rmdir($dir);
				}
				
				if(is_dir($file)) {
					rrmdir($file);
				}
				else {
					unlink($file);
				}
			}
		}
		if($action == "rename-file") {
			$location = str_replace("../", "", $_POST['location']);
			$new_name = $_POST['name'];
			$file = "../files/" . $location;
			if(is_dir($file)) {
				$file = "../files" . $location . "/";
			}
			$basename = basename($file);
			$directory = str_replace($basename, "", $file);
			$rename = $directory . $new_name;
			
			$file_extension = str_replace($new_name, "", array_pop(explode(".", $new_name)));
			if(!empty($file_extension)) {
				$file_extension = "." . $file_extension;
			}
			
			$new_name_no_extension = str_replace($file_extension, "", $new_name);
			
			if(file_exists($rename)) {
				$i = 1;
				while(file_exists($rename)) {
					$rename = $directory . $new_name_no_extension . " (" . $i . ")" . $file_extension;
					$i++;
				}
			}
			
			if(realpath($file) != realpath("../files/")) {
				rename($file, $rename);
			}
		}
		if($action == "download-file") {
			$location = str_replace("../", "", $_POST['location']);
			$file = "../files/" . $location;
			$basename = basename($location);
			$mime = mime_content_type($file);
			
			header('Content-Type: ' . $mime);
			header('Content-Disposition: attachment; filename="' . $basename . '"');
			readfile($file);
		}
		if($action == "upload-profile-pic") {
			$temp = $_FILES['file']['tmp_name'];
			$name = $_FILES['file']['name'];
			$extension = strtolower(array_pop(explode(".", $name)));
			$whitelist = ["jpg","jpeg","png","gif"];
			if(in_array($extension, $whitelist)) {
				$pics = glob("../images/profile-pic.*");
				foreach($pics as $pic) {
					unlink($pic);
				}
				move_uploaded_file($temp, "../images/profile-pic." . $extension);
			}
			header("Location: ../index.php");
		}
		if($action == "delete-profile-pic") {
			$pics = glob("../images/profile-pic.*");
			foreach($pics as $pic) {
				unlink($pic);
			}
		}
		if($action == "change-username") {
			$new_username = $_POST['input'];
			$settings_current = json_decode(file_get_contents("../source/cfg/preferences.config"), true);
			$settings_username = $settings_current['username'];
			$settings_password = $settings_current['password'];
			$settings = ["username" => $new_username, "password" => $settings_password];
			file_put_contents("../source/cfg/preferences.config", json_encode($settings));
		}
		if($action == "change-password") {
			$new_password = $_POST['input'];
			$settings_current = json_decode(file_get_contents("../source/cfg/preferences.config"), true);
			$settings_username = $settings_current['username'];
			$settings_password = $settings_current['password'];
			$settings = ["username" => $settings_username, "password" => hash("sha512", $new_password)];
			file_put_contents("../source/cfg/preferences.config", json_encode($settings));
		}
		if($action == "delete-all-files") {
			$location = "../files/";
			$files = glob($location . "*");
			
			function rrmdir($dir) {
				$structure = glob(rtrim($dir, "/") . '/*');
				if(is_array($structure)) {
					foreach($structure as $file) {
						if(is_dir($file)) rrmdir($file);
						elseif(is_file($file)) unlink($file);
					}
				}
				rmdir($dir);
			}
			
			foreach($files as $file) {
				if(realpath($file) != realpath("../files/")) {
					if(is_dir($file)) {
						rrmdir($file);
					}
					else {
						unlink($file);
					}
				}
			}
		}
	}
?>